/**

   Utilisation d'une map pour raliser un dico!

   @author: ErgoIT 2000 (http://www.ergoit.co.uk)
   @author: Mohamed Lokbani pour le passage en franais!

   @version 1.1

   
*/


import java.util.*;

class Def {
    static final int VERBE = 0;
    static final int NOM = 1;
    static final int ADJECTIVE = 2;
    static final int ADVERBE = 3;
    
    int type;
    String description;
    
    
    public Def (int word_type, String word_describe) {
        type = word_type;
        description = word_describe;
    }
    
    public String toString () {
        switch (type) {
	case      VERBE : return "[verbe] : "+description;
	case        NOM : return "[nom] : "+description;
	case  ADJECTIVE : return "[adj.] : "+description;
	case    ADVERBE : return "[adverbe] : "+description;
	default         : return "";
	}
    }
}

public class Dico
{
    public static void main(String[] args)
    {

	/*
	   COMPLTER

	  instanciez un objet map du type TreeMap ... 

	*/



        TreeMap map = new TreeMap();


	/*

	   COMPLTER
	  
	  insrez les donnes du dico comme suit:

	  1er: cl d'entre
	  2e: valeur associe
	
	  certainement: 
	               Def.ADVERBE: vraiment, vritablement, exactement, justement.
	  dbarrasser:
	               Def.VERBE: Enlever ce qui gne.

          gaffe:
	               Def.NOM: Bvue grossire.

	  imaginaire:
	               Def.ADJECTIVE: fabuleux, fantastique, utopique, chimrique.

	  ressource:
	               Def.NOM: Ce qu'on emploie pour obtenir un rsultat.

	*/



        map.put("certainement",new Def(Def.ADVERBE,"vraiment, vritablement, exactement, justement."));
        map.put("dbarrasser",new Def(Def.VERBE,"Enlever ce qui gne."));
        map.put("gaffe",new Def(Def.NOM,"Bvue grossire."));
        map.put("imaginaire",new Def(Def.ADJECTIVE,"fabuleux, fantastique, utopique, chimrique."));
        map.put("ressource",new Def(Def.NOM,"Ce qu'on emploie pour obtenir un rsultat."));
	

	/*

	   COMPLTER

	  recherchez si un mot est dans le dico
	  
	  
	  certainement
 
          gaffe
 
          imaginaire
 
          ressource                  

	  l'affichage doit tre  chaque fois comme suit:

	  par exemple pour le mot "gaffe"


	  if (xxxxxxxxxxxxxxxx)
            System.out.println("'gaffe' "+xxxxxxxxxxxxx+"\n");
	  else
            System.out.println("'gaffe' n'est pas dans le dictionnaire\n");

	*/
 

        if (map.containsKey("gaffe"))
           System.out.println("'gaffe' "+map.get("gaffe")+"\n");
        else
           System.out.println("'gaffe' n'est pas dans le dictionnaire\n");


	if (map.containsKey("imaginaire"))
           System.out.println("'imaginaire' "+map.get("imaginaire")+"\n");
        else
           System.out.println("'imaginaire' n'est pas dans le dictionnaire\n");


	if (map.containsKey("machine"))
           System.out.println("'machine' "+map.get("machine")+"\n");
        else
           System.out.println("'machine' n'est pas dans le dictionnaire\n");


	if (map.containsKey("certainement"))
           System.out.println("'certainement' "+map.get("certainement")+"\n");
        else
           System.out.println("'certainement' n'est pas dans le dictionnaire\n");



	/*

	   COMPLTER

	  afficher le premier mot du dico
	  et le dernier mot du dico

	*/

        System.out.println("Premier mot du dictionnaire: "+map.firstKey()+"\n");
        System.out.println("Dernier mot du dictionnaire: "+map.lastKey()+"\n");


    }
}



/*

'gaffe' [nom] : Bvue grossire.
 
'imaginaire' [adj.] : fabuleux, fantastique, utopique, chimrique.
 
'machine' n'est pas dans le dictionnaire
 
'certainement' [adverbe] : vraiment, vritablement, exactement, justement.
 
Premier mot du dictionnaire: certainement
 
Dernier mot du dictionnaire: ressource

*/
